﻿using System;
using System.Windows.Input;

namespace WpfWVVMSample
{
    class DelegateCommand : ICommand
    {
        private Action<object> _execute;

        private Func<Object, bool> _canExecute;

        public DelegateCommand(Action<Object> execute) : this(execute, null)
        {
        }

        public DelegateCommand(Action<Object> execute, Func<object, bool> canExecute)
        {
            this._execute = execute;
            this._canExecute = canExecute;
        }

        public event EventHandler CanExecuteChanged;

        public bool CanExecute(object parameter)
        {
            if (this._canExecute != null)
            {
                return this._canExecute(parameter);
            }
            else
            {
                return true;
            }
        }

        public void RaiseCanExecuteChanged()
        {
            var h = this.CanExecuteChanged;
            if (h != null) h(this, EventArgs.Empty);
        }
        public void Execute(object parameter)
        {
            if (this._execute != null) {
                this._execute(parameter);
            }
        }
    }
}
